package com.liquidnet.service.goblin.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * NFT订单表
 * </p>
 *
 * @author jiangxiulong
 * @since 2022-03-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class GoblinNftOrder implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "mid", type = IdType.AUTO)
    private Long mid;

    /**
     * 订单id
     */
    private String orderId;

    /**
     * 商品id
     */
    private String spuId;

    /**
     * 款式id
     */
    private String skuId;

    /**
     * 数量
     */
    private Integer num;

    /**
     * 店铺id
     */
    private String storeId;

    /**
     * 商铺名称
     */
    private String storeName;

    /**
     * 订单号
     */
    private String orderCode;

    /**
     * 用户id
     */
    private String userId;

    /**
     * 用户昵称
     */
    private String userName;

    /**
     * 用户手机号
     */
    private String userMobile;

    /**
     * 是否会员
     */
    private Integer isMember;

    /**
     * 应付金额
     */
    private BigDecimal priceTotal;

    /**
     * 券优惠金额
     */
    private BigDecimal priceCoupon;

    /**
     * 商铺券优惠金额
     */
    private BigDecimal storePriceCoupon;

    /**
     * 红包优惠金额
     */
    private BigDecimal priceRedEnvelope;

    /**
     * 总优惠价格
     */
    private BigDecimal priceVoucher;

    /**
     * 实付金额
     */
    private BigDecimal priceActual;

    /**
     * 券id
     */
    private String ucouponId;

    /**
     * 商铺券id
     */
    private String storeCouponId;

    /**
     * 红包code
     */
    private String redEnvelopeCode;

    /**
     * 订单状态 0-待付款(用户刚下单)|1-已付款|2-已取消(未付款取消订单)|3-已退款(超时支付)
     */
    private Integer status;

    /**
     * 订单来源 app|h5|applet
     */
    private String source;

    /**
     * 订单类型 0-购买订单|1-兑换订单|2-演出赠送订单
     */
    private Integer orderType;

    /**
     * 支付时间
     */
    private LocalDateTime payTime;

    /**
     * 支付单号
     */
    private String payCode;

    /**
     * 支付类型 wepay-微信支付|alipay-阿里支付|douyinpay-抖音支付|unionpay-银联支付
     */
    private String payType;

    /**
     * 支付类型来源[wap|js]
     */
    private String deviceFrom;

    /**
     * 支付中心返回实际支付类型
     */
    private String paymentType;

    /**
     * 支付中心返回支付id
     */
    private String paymentId;

    /**
     * 钱到了哪个支付平台  平台的订单id为'
     */
    private String payStoreId;

    /**
     * 订单过期时间(分钟)
     */
    private Integer payCountdownMinute;

    /**
     * 取消原因
     */
    private String cancelReason;

    /**
     * 取消时间
     */
    private LocalDateTime cancelTime;

    /**
     * 版本号
     */
    private String version;

    /**
     * ip地址
     */
    private String ipAddress;

    /**
     * ip地域全名称
     */
    private String area;

    /**
     * ip地域省
     */
    private String areaProvince;

    /**
     * ip地域市
     */
    private String areaCity;

    /**
     * ip地域县
     */
    private String areaCounty;

    /**
     * 创建时间
     */
    private LocalDateTime createdAt;

    /**
     * 更新时间
     */
    private LocalDateTime updatedAt;

    private static final GoblinNftOrder obj = new GoblinNftOrder();

    public static GoblinNftOrder getNew() {
        try {
            return (GoblinNftOrder) obj.clone();
        } catch (CloneNotSupportedException e) {
            return new GoblinNftOrder();
        }
    }


}
